local opacity = 0.3 -- Set the visibility, 0 being invisible

local raid_frame = CreateFrame("Frame");
local begin_frame = CreateFrame("Frame");

local groupsAndMembersArray = {}
for i = 1,8 do
  groupsAndMembersArray[i] = {}
  for j = 1,5 do
     groupsAndMembersArray[i][j] = string.format("CompactRaidGroup%dMember%d", i,j)
  end
end

local raidMembersArray = {}
for i = 1,40 do
  raidMembersArray[i] = string.format("CompactRaidFrame%d", i) 
end

local function set_opacity(raidmember)
  if raidmember then
    local transparency;

    if raidmember:GetAlpha() < 0.8 then
      transparency = opacity;
    else
      transparency = 1;
    end
    
    select(1,raidmember:GetRegions()):SetAlpha(transparency); -- Background
    select(7,raidmember:GetRegions()):SetAlpha(transparency); -- Name Text
    select(1,raidmember:GetChildren()):SetAlpha(transparency); -- Health Bar
    select(2,raidmember:GetChildren()):SetAlpha(transparency); -- Mana Bar
  end
end

local function raid_update(self, elapsed)

  --Keep Groups Together Unchecked
  for i=1, 40 do
      local raidmember = _G[raidMembersArray[i]];
      set_opacity(raidmember);
  end

  -- Keep Groups Together Checked
  for i=1, 8 do
    for j=1,5 do
      local raidmember = _G[groupsAndMembersArray[i][j]];
      set_opacity(raidmember);
    end
  end

end

local function begin()
  raid_frame:SetScript("OnUpdate", raid_update);
end

begin_frame:RegisterEvent("PLAYER_ENTERING_WORLD");
begin_frame:RegisterEvent("GROUP_ROSTER_UPDATE");
begin_frame:RegisterEvent("RAID_ROSTER_UPDATE");

begin_frame:SetScript("OnEvent", begin);
